CREATE TABLE IF NOT EXISTS news(
  id bigint not null auto_increment,
  clean_title varchar(255),
  menu_title varchar(255) default '',
  title varchar(255),
  short_content text,
  content text,
  html_title varchar(255) default '',
  html_keywords varchar(255) default '',
  html_description varchar(255) default '',
  pic varchar(50) default '',
  pic_w int default '0',
  pic_h int default '0',
  pic_t int default '0',
  pic_tn_w int default '0',
  pic_tn_h int default '0',
  date datetime,
  visible tinyint default '1',
  order_num bigint,
  karma int default '0',
  comments_count int default '0',
  comments_last_date datetime default NULL,
  comments_enabled tinyint default '1',
  unique clean_title(clean_title),
  key visible_idx(visible,order_num,date),
  primary key(id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;
